/* 
   $Id: atoms.c,v 1.5 2001/12/25 05:15:34 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "sgwm.h"
#include <stdio.h>
#include <gdk/gdkx.h>
#include "atoms.h"

struct sgatom {
    char *name;
    Atom *handle;
};

Atom xa_sg_wm;
Atom xa_sgws_swap;
Atom xa_sgws_enable;
Atom xa_sgws_activate;
Atom xa_sgws_resize;
Atom xa_sgws_mapws;
Atom xa_sgws_calldt;
Atom xa_sgws_map;
Atom xa_sgws_roll_up;
Atom xa_sgws_roll_down;
Atom xa_sgws_move_next;
Atom xa_sgws_move_prev;
Atom xa_sg_menubar;
Atom xa_sg_toolbar;
Atom xa_sg_imbar;
Atom xa_sg_barwindow;
Atom xa_sg_panel;
Atom xa_sg_nunome;
Atom xa_sg_desktop;
Atom xa_nunome_popup;
Atom xa_nunome;
Atom xa_win_supporting_wm_check;
Atom xa_win_protocols;
Atom xa_win_layer;
Atom xa_win_state;
Atom xa_win_app_state;
Atom xa_win_expanded_size;
Atom xa_win_icons;
Atom xa_win_workspace;
Atom xa_win_workspace_count;
Atom xa_win_workspace_names;
Atom xa_win_client_list;
Atom xa_win_hints;
Atom xa_win_supporting_wm_check;
Atom xa_sg_wm;
Atom xa_wm_change_state;
Atom xa_wm_state;
Atom xa_wm_colormap_windows;
Atom xa_wm_protocols;
Atom xa_wm_take_focus;
Atom xa_wm_save_yourself;
Atom xa_wm_delete_window;
Atom xa_sm_client_id;
Atom xa_wm_client_leader;
Atom xa_wm_window_role;
Atom xa_version;
Atom xa_manager;
Atom xa_wm_s;
Atom xa_gtk_rcfiles;

static struct sgatom atoms[] = {
    {"_AXE_SG_WM",&xa_sg_wm},
    {"_AXE_SGWS_SWAP",&xa_sgws_swap},
    {"_AXE_SGWS_ENABLE",&xa_sgws_enable},
    {"_AXE_SGWS_ACTIVATE",&xa_sgws_activate},
    {"_AXE_SGWS_RESIZE",&xa_sgws_resize},
    {"_AXE_SGWS_MAPWS",&xa_sgws_mapws},
    {"_AXE_SGWS_CALLDT",&xa_sgws_calldt},
    {"_AXE_SGWS_MAP",&xa_sgws_map},
    {"_AXE_SGWS_ROLL_UP",&xa_sgws_roll_up},
    {"_AXE_SGWS_ROLL_DOWN",&xa_sgws_roll_down},
    {"_AXE_SGWS_MOVE_NEXT",&xa_sgws_move_next},
    {"_AXE_SGWS_MOVE_PREV",&xa_sgws_move_prev},
    {"_AXE_SG_MENUBAR",&xa_sg_menubar},
    {"_AXE_SG_TOOLBAR",&xa_sg_toolbar},
    {"_AXE_SG_IMBAR",&xa_sg_imbar},
    {"_AXE_SG_BARWINDOW",&xa_sg_barwindow},
    {"_AXE_SG_PANEL",&xa_sg_panel},
    {"_AXE_SG_NUNOME",&xa_sg_nunome},
    {"_AXE_SG_DESKTOP",&xa_sg_desktop},
    {"NUNOME_POPUP",&xa_nunome_popup},
    {"@server=_NUNOME",&xa_nunome},
    {"_WIN_SUPPORTING_WM_CHECK",&xa_win_supporting_wm_check},
    {"_WIN_PROTOCOLS",&xa_win_protocols},
    {"_WIN_LAYER",&xa_win_layer},
    {"_WIN_STATE",&xa_win_state},
    {"_WIN_APP_STATE",&xa_win_app_state},
    {"_WIN_EXPANDED_SIZE",&xa_win_expanded_size},
    {"_WIN_ICONS",&xa_win_icons},
    {"_WIN_WORKSPACE",&xa_win_workspace},
    {"_WIN_WORKSPACE_COUNT",&xa_win_workspace_count},
    {"_WIN_WORKSPACE_NAMES",&xa_win_workspace_names},
    {"_WIN_CLIENT_LIST",&xa_win_client_list},
    {"_WIN_HINTS",&xa_win_hints},
    {"WM_CHANGE_STATE",&xa_wm_change_state},
    {"WM_STATE",&xa_wm_state},
    {"WM_COLORMAP_WINDOWS",&xa_wm_colormap_windows},
    {"WM_PROTOCOLS",&xa_wm_protocols},
    {"WM_TAKE_FOCUS",&xa_wm_take_focus},
    {"WM_SAVE_YOURSELF",&xa_wm_save_yourself},
    {"WM_DELETE_WINDOW",&xa_wm_delete_window},
    {"SM_CLIENT_ID",&xa_sm_client_id},
    {"WM_CLIENT_LEADER",&xa_wm_client_leader},
    {"WM_WINDOW_ROLE",&xa_wm_window_role},
    {"VERSION",&xa_version},
    {"MANAGER",&xa_manager},
    {"_GTK_READ_RCFILES",&xa_gtk_rcfiles},
    {NULL,NULL}
};

void intern_atoms()
{
    struct sgatom *p;
    char buf[256];

    for (p = atoms;p->name != NULL;p++) {
	*(p->handle) = XInternAtom(GDK_DISPLAY(),p->name,False);
    }
    sprintf(buf,"WM_S%d",DefaultScreen(GDK_DISPLAY()));
    xa_wm_s = XInternAtom(GDK_DISPLAY(),buf,False);
}
