/* 
   $Id: sgworkspace.h,v 1.6 2001/12/25 05:15:36 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __SGWORKSPACE_H__
#define __SGWORKSPACE_H__

typedef struct _SGWorkSpace SGWorkSpace;
typedef struct _SGWorkSpaceClass SGWorkSpaceClass;

#include <gdk/gdk.h>
#include <gtk/gtkcontainer.h>
#include <gtk/gtkadjustment.h>
#include "sgwindow.h"
#include "sgwmwidget.h"

#define SGWORKSPACE(obj) (GTK_CHECK_CAST((obj),GTK_TYPE_SGWORKSPACE,SGWorkSpace))
#define SGWORKSPACE_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass),\
	GTK_TYPE_SGWORKSPACE,SGWorkSpace))
#define IS_SGWORKSPACE(obj) (GTK_CHECK_TYPE((obj),GTK_TYPE_SGWORKSPACE))

#define GTK_TYPE_SGWORKSPACE (sgworkspace_get_type())


struct _SGWorkSpace {
    GtkContainer container;
    SGWMWidget *sgwm;
    GdkWindow *view_window;
    GdkWindow *bin_window;
    GList *children;
    GtkAdjustment *hadj;
    GtkAdjustment *vadj;
    gint8 no;
    gboolean disabled;
    gboolean nunome;
    Window cover;
    gint8 coverCount;
    gboolean childrenChanged;
};

struct _SGWorkSpaceClass {
    GtkContainerClass parent_class;

    void  (*set_scroll_adjustments)(SGWorkSpace *ws,
				    GtkAdjustment *hadj,
                                    GtkAdjustment *vadj);

};

extern GtkType sgworkspace_get_type(void);
extern GtkWidget *sgworkspace_new(SGWMWidget *sgwm, GtkAdjustment *hadj,
  GtkAdjustment *vadj, gint no);
extern void sgworkspace_add(GtkContainer *ws, GtkWidget *sgwin);
extern void sgworkspace_remove(GtkContainer *ws, GtkWidget *sgwin);
extern gboolean sgworkspace_in(SGWorkSpace *sgws, int x, int y);
extern void sgworkspace_calculate_child_size(SGWorkSpace *ws,
  SGWindow *sgwin, GtkAllocation *newalloc);
extern void sgworkspace_warp_pointer(SGWorkSpace *sgws);
extern void sgworkspace_cover(GtkWidget *widget);
extern void sgworkspace_uncover(GtkWidget *widget);
extern void sgworkspace_send_client_message(GtkWidget *widget, GdkEvent *ev);

#endif
